diff --git a/src/Umbraco.Core/Routing/ContentFinderByRedirectUrl.cs b/src/Umbraco.Core/Routing/ContentFinderByRedirectUrl.cs
index 99103d8cb6..6b5e1590c1 100644
--- a/src/Umbraco.Core/Routing/ContentFinderByRedirectUrl.cs
+++ b/src/Umbraco.Core/Routing/ContentFinderByRedirectUrl.cs
@@ -45,11 +45,11 @@ public class ContentFinderByRedirectUrl : IContentFinder
     ///     Optionally, can also assign the template or anything else on the document request, although that is not
     ///     required.
     /// </remarks>
-    public Task<bool> TryFindContent(IPublishedRequestBuilder frequest)
+    public async Task<bool> TryFindContent(IPublishedRequestBuilder frequest)
     {
         if (!_umbracoContextAccessor.TryGetUmbracoContext(out IUmbracoContext? umbracoContext))
         {
-            return Task.FromResult(false);
+            return false;
         }
 
         var route = frequest.Domain != null
@@ -57,7 +57,7 @@ public class ContentFinderByRedirectUrl : IContentFinder
               DomainUtilities.PathRelativeToDomain(frequest.Domain.Uri, frequest.AbsolutePathDecoded)
             : frequest.AbsolutePathDecoded;
 
-        IRedirectUrl? redirectUrl = _redirectUrlService.GetMostRecentRedirectUrl(route, frequest.Culture);
+        IRedirectUrl? redirectUrl = await _redirectUrlService.GetMostRecentRedirectUrlAsync(route, frequest.Culture);
 
         if (redirectUrl == null)
         {
@@ -66,7 +66,7 @@ public class ContentFinderByRedirectUrl : IContentFinder
                 _logger.LogDebug("No match for route: {Route}", route);
             }
 
-            return Task.FromResult(false);
+            return false;
         }
 
         IPublishedContent? content = umbracoContext.Content?.GetById(redirectUrl.ContentId);
@@ -78,7 +78,7 @@ public class ContentFinderByRedirectUrl : IContentFinder
                 _logger.LogDebug("Route {Route} matches content {ContentId} which has no URL.", route, redirectUrl.ContentId);
             }
 
-            return Task.FromResult(false);
+            return false;
         }
 
         // Appending any querystring from the incoming request to the redirect URL
@@ -99,6 +99,6 @@ public class ContentFinderByRedirectUrl : IContentFinder
             .SetCacheExtensions(new List<string> { "no-store, must-revalidate" })
             .SetHeaders(new Dictionary<string, string> { { "Pragma", "no-cache" }, { "Expires", "0" } });
 
-        return Task.FromResult(true);
+        return true;
     }
 }
diff --git a/src/Umbraco.Core/Services/IFileService.cs b/src/Umbraco.Core/Services/IFileService.cs
index 3179a4491f..53d7d004b2 100644
--- a/src/Umbraco.Core/Services/IFileService.cs
+++ b/src/Umbraco.Core/Services/IFileService.cs
@@ -8,7 +8,8 @@ namespace Umbraco.Cms.Core.Services;
 /// </summary>
 public interface IFileService : IService
 {
-    [Obsolete("Please use SnippetCollection.GetPartialViewSnippetNames() or SnippetCollection.GetPartialViewMacroSnippetNames() instead. Scheduled for removal in V12.")]IEnumerable<string> GetPartialViewSnippetNames(params string[] filterNames);
+    [Obsolete("Please use SnippetCollection.GetPartialViewSnippetNames() or SnippetCollection.GetPartialViewMacroSnippetNames() instead. Scheduled for removal in V12.")]
+    IEnumerable<string> GetPartialViewSnippetNames(params string[] filterNames);
 
     void CreatePartialViewFolder(string folderPath);
 
@@ -308,12 +309,13 @@ public interface IFileService : IService
     /// <param name="snippetName">The name of the snippet</param>
     /// <returns></returns>
     [Obsolete("Please use SnippetCollection.GetPartialViewMacroSnippetContent instead. Scheduled for removal in V12.")]
-        string GetPartialViewMacroSnippetContent(string snippetName);
+    string GetPartialViewMacroSnippetContent(string snippetName);
 
     /// <summary>
     ///     Gets the content of a partial view snippet as a string.
     /// </summary>
     /// <param name="snippetName">The name of the snippet</param>
     /// <returns>The content of the partial view.</returns>
-    [Obsolete("Please use SnippetCollection.GetPartialViewSnippetContent instead. Scheduled for removal in V12.")]string GetPartialViewSnippetContent(string snippetName);
+    [Obsolete("Please use SnippetCollection.GetPartialViewSnippetContent instead. Scheduled for removal in V12.")]
+    string GetPartialViewSnippetContent(string snippetName);
 }
diff --git a/src/Umbraco.Core/Services/IRedirectUrlService.cs b/src/Umbraco.Core/Services/IRedirectUrlService.cs
index 9da327a600..f1897053f0 100644
--- a/src/Umbraco.Core/Services/IRedirectUrlService.cs
+++ b/src/Umbraco.Core/Services/IRedirectUrlService.cs
@@ -1,3 +1,4 @@
+﻿using System.Threading.Tasks;
 using Umbraco.Cms.Core.Models;
 
 namespace Umbraco.Cms.Core.Services;
@@ -54,6 +55,14 @@ public interface IRedirectUrlService : IService
     IRedirectUrl? GetMostRecentRedirectUrl(string url, string? culture);
 
     /// <summary>
+    /// Gets the most recent redirect URLs corresponding to an Umbraco redirect URL route.
+    /// </summary>
+    /// <param name="url">The Umbraco redirect URL route.</param>
+    /// <param name="culture">The culture of the request.</param>
+    /// <returns>The most recent redirect URLs corresponding to the route.</returns>
+    Task<IRedirectUrl?> GetMostRecentRedirectUrlAsync(string url, string? culture) => Task.FromResult(GetMostRecentRedirectUrl(url, culture));
+
+        /// <summary>
     ///     Gets all redirect URLs for a content item.
     /// </summary>
     /// <param name="contentKey">The content unique key.</param>
diff --git a/src/Umbraco.Core/Services/PropertyValidationService.cs b/src/Umbraco.Core/Services/PropertyValidationService.cs
index d93cbd4a7c..fc42b13232 100644
--- a/src/Umbraco.Core/Services/PropertyValidationService.cs
+++ b/src/Umbraco.Core/Services/PropertyValidationService.cs
@@ -182,8 +182,8 @@ public class PropertyValidationService : IPropertyValidationService
         var pvalues = property.Values.Where(x =>
                 x != pvalue && // don't revalidate pvalue
                 property.PropertyType.SupportsVariation(x.Culture, x.Segment, true) && // the value variation is ok
-                (culture == "*" || (x.Culture?.InvariantEquals(culture) ?? false)) && // the culture matches
-                (segment == "*" || (x.Segment?.InvariantEquals(segment) ?? false))) // the segment matches
+                    (culture == "*" || x.Culture.InvariantEquals(culture)) && // the culture matches
+                    (segment == "*" || x.Segment.InvariantEquals(segment))) // the segment matches
             .ToList();
 
         return pvalues.Count == 0 || pvalues.All(x => IsValidPropertyValue(property, x.EditedValue));
diff --git a/src/Umbraco.Core/Services/RedirectUrlService.cs b/src/Umbraco.Core/Services/RedirectUrlService.cs
index e68eed31e7..07646de3de 100644
--- a/src/Umbraco.Core/Services/RedirectUrlService.cs
+++ b/src/Umbraco.Core/Services/RedirectUrlService.cs
@@ -1,4 +1,5 @@
-﻿using Microsoft.Extensions.Logging;
+﻿using System.Threading.Tasks;
+using Microsoft.Extensions.Logging;
 using Umbraco.Cms.Core.Events;
 using Umbraco.Cms.Core.Models;
 using Umbraco.Cms.Core.Persistence.Repositories;
@@ -81,6 +82,14 @@ internal class RedirectUrlService : RepositoryService, IRedirectUrlService
         }
     }
 
+    public async Task<IRedirectUrl?> GetMostRecentRedirectUrlAsync(string url)
+    {
+        using (var scope = ScopeProvider.CreateCoreScope(autoComplete: true))
+        {
+            return await _redirectUrlRepository.GetMostRecentUrlAsync(url);
+        }
+    }
+
     public IEnumerable<IRedirectUrl> GetContentRedirectUrls(Guid contentKey)
     {
         using (ICoreScope scope = ScopeProvider.CreateCoreScope(autoComplete: true))
@@ -125,4 +134,17 @@ internal class RedirectUrlService : RepositoryService, IRedirectUrlService
             return _redirectUrlRepository.GetMostRecentUrl(url, culture);
         }
     }
+
+    public async Task<IRedirectUrl?> GetMostRecentRedirectUrlAsync(string url, string? culture)
+    {
+        if (string.IsNullOrWhiteSpace(culture))
+        {
+            return await GetMostRecentRedirectUrlAsync(url);
+        }
+
+        using (var scope = ScopeProvider.CreateCoreScope(autoComplete: true))
+        {
+            return await _redirectUrlRepository.GetMostRecentUrlAsync(url, culture);
+        }
+    }	
 }
diff --git a/src/Umbraco.Core/Trees/ISearchableTreeWithCulture.cs b/src/Umbraco.Core/Trees/ISearchableTreeWithCulture.cs
new file mode 100644
index 0000000000..6ac4ea3be1
--- /dev/null
+++ b/src/Umbraco.Core/Trees/ISearchableTreeWithCulture.cs
@@ -0,0 +1,21 @@
+using Umbraco.Cms.Core.Models.ContentEditing;
+
+namespace Umbraco.Cms.Core.Trees
+{
+    [Obsolete("This interface will be merged into ISearchableTree in Umbraco 12")]
+    public interface ISearchableTreeWithCulture : ISearchableTree
+    {
+        /// <summary>
+        /// Searches for results based on the entity type
+        /// </summary>
+        /// <param name="query"></param>
+        /// <param name="pageSize"></param>
+        /// <param name="pageIndex"></param>
+        /// <param name="searchFrom">
+        ///     A starting point for the search, generally a node id, but for members this is a member type alias
+        /// </param>
+        /// <param name="culture"></param>
+        /// <returns></returns>
+        Task<EntitySearchResults> SearchAsync(string query, int pageSize, long pageIndex, string? searchFrom = null, string? culture = null);
+    }
+}
diff --git a/src/Umbraco.Core/Trees/MenuItemList.cs b/src/Umbraco.Core/Trees/MenuItemList.cs
index a4cb1899e3..cb912a112b 100644
--- a/src/Umbraco.Core/Trees/MenuItemList.cs
+++ b/src/Umbraco.Core/Trees/MenuItemList.cs
@@ -32,9 +32,20 @@ public class MenuItemList : List<MenuItem>
     /// <param name="textService">The <see cref="ILocalizedTextService" /> used to localize the action name based on its alias</param>
     /// <param name="opensDialog">Whether or not this action opens a dialog</param>
     public MenuItem? Add<T>(ILocalizedTextService textService, bool hasSeparator = false, bool opensDialog = false)
+        where T : IAction => Add<T>(textService, hasSeparator, opensDialog, useLegacyIcon: true);
+
+    /// <summary>
+    ///     Adds a menu item with a dictionary which is merged to the AdditionalData bag
+    /// </summary>
+    /// <typeparam name="T"></typeparam>
+    /// <param name="hasSeparator"></param>
+    /// <param name="textService">The <see cref="ILocalizedTextService" /> used to localize the action name based on its alias</param>
+    /// <param name="opensDialog">Whether or not this action opens a dialog</param>
+    /// <param name="useLegacyIcon">Whether or not this action should use legacy icon prefixed with "icon-" or full icon name is specified.</param>
+    public MenuItem? Add<T>(ILocalizedTextService textService, bool hasSeparator = false, bool opensDialog = false, bool useLegacyIcon = true)
         where T : IAction
     {
-        MenuItem? item = CreateMenuItem<T>(textService, hasSeparator, opensDialog);
+        MenuItem? item = CreateMenuItem<T>(textService, hasSeparator, opensDialog, useLegacyIcon);
         if (item != null)
         {
             Add(item);
@@ -44,7 +55,7 @@ public class MenuItemList : List<MenuItem>
         return null;
     }
 
-    private MenuItem? CreateMenuItem<T>(ILocalizedTextService textService, bool hasSeparator = false, bool opensDialog = false)
+    private MenuItem? CreateMenuItem<T>(ILocalizedTextService textService, bool hasSeparator = false, bool opensDialog = false, bool useLegacyIcon = true)
         where T : IAction
     {
         T? item = _actionCollection.GetAction<T>();
@@ -61,6 +72,7 @@ public class MenuItemList : List<MenuItem>
             SeparatorBefore = hasSeparator,
             OpensDialog = opensDialog,
             TextDescription = textDescription,
+            UseLegacyIcon = useLegacyIcon,
         };
 
         return menuItem;
diff --git a/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.Collections.cs b/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.Collections.cs
index bc83695d94..609c5305dc 100644
--- a/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.Collections.cs
+++ b/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.Collections.cs
@@ -2,6 +2,7 @@ using Umbraco.Cms.Core.DependencyInjection;
 using Umbraco.Cms.Core.Packaging;
 using Umbraco.Cms.Infrastructure.Persistence;
 using Umbraco.Cms.Infrastructure.Persistence.Mappers;
+using Umbraco.Cms.Infrastructure.Runtime;
 
 namespace Umbraco.Extensions;
 
@@ -17,6 +18,10 @@ public static partial class UmbracoBuilderExtensions
     public static MapperCollectionBuilder? Mappers(this IUmbracoBuilder builder)
         => builder.WithCollectionBuilder<MapperCollectionBuilder>();
 
+    /// <summary>
+    ///     Gets the NPoco mappers collection builder.
+    /// </summary>
+    /// <param name="builder">The builder.</param>
     public static NPocoMapperCollectionBuilder? NPocoMappers(this IUmbracoBuilder builder)
         => builder.WithCollectionBuilder<NPocoMapperCollectionBuilder>();
 
@@ -26,4 +31,11 @@ public static partial class UmbracoBuilderExtensions
     /// <param name="builder">The builder.</param>
     public static PackageMigrationPlanCollectionBuilder? PackageMigrationPlans(this IUmbracoBuilder builder)
         => builder.WithCollectionBuilder<PackageMigrationPlanCollectionBuilder>();
+
+    /// <summary>
+    ///     Gets the runtime mode validators collection builder.
+    /// </summary>
+    /// <param name="builder">The builder.</param>
+    public static RuntimeModeValidatorCollectionBuilder RuntimeModeValidators(this IUmbracoBuilder builder)
+        => builder.WithCollectionBuilder<RuntimeModeValidatorCollectionBuilder>();
 }
diff --git a/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.CoreServices.cs b/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.CoreServices.cs
index 1c874b2efa..62bafcd28e 100644
--- a/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.CoreServices.cs
+++ b/src/Umbraco.Infrastructure/DependencyInjection/UmbracoBuilder.CoreServices.cs
@@ -86,11 +86,12 @@ public static partial class UmbracoBuilderExtensions
 
         // Add runtime mode validation
         builder.Services.AddSingleton<IRuntimeModeValidationService, RuntimeModeValidationService>();
-        builder.Services.AddTransient<IRuntimeModeValidator, JITOptimizerValidator>();
-        builder.Services.AddTransient<IRuntimeModeValidator, UmbracoApplicationUrlValidator>();
-        builder.Services.AddTransient<IRuntimeModeValidator, UseHttpsValidator>();
-        builder.Services.AddTransient<IRuntimeModeValidator, RuntimeMinificationValidator>();
-        builder.Services.AddTransient<IRuntimeModeValidator, ModelsBuilderModeValidator>();
+        builder.RuntimeModeValidators()
+            .Add<JITOptimizerValidator>()
+            .Add<UmbracoApplicationUrlValidator>()
+            .Add<UseHttpsValidator>()
+            .Add<RuntimeMinificationValidator>()
+            .Add<ModelsBuilderModeValidator>();
 
         // composers
         builder
@@ -219,6 +220,8 @@ public static partial class UmbracoBuilderExtensions
 
         // Services required to run background jobs (with out the handler)
         builder.Services.AddSingleton<IBackgroundTaskQueue, BackgroundTaskQueue>();
+
+        builder.Services.AddTransient<IFireAndForgetRunner, FireAndForgetRunner>();
         return builder;
     }
 
diff --git a/src/Umbraco.Infrastructure/Install/InstallHelper.cs b/src/Umbraco.Infrastructure/Install/InstallHelper.cs
index 41e9d13ed8..85839e8757 100644
--- a/src/Umbraco.Infrastructure/Install/InstallHelper.cs
+++ b/src/Umbraco.Infrastructure/Install/InstallHelper.cs
@@ -1,3 +1,4 @@
+using Microsoft.Extensions.DependencyInjection;
 using Microsoft.Extensions.Logging;
 using Microsoft.Extensions.Options;
 using Umbraco.Cms.Core;
@@ -9,6 +10,7 @@ using Umbraco.Cms.Core.Services;
 using Umbraco.Cms.Core.Web;
 using Umbraco.Cms.Infrastructure.Migrations.Install;
 using Umbraco.Cms.Infrastructure.Persistence;
+using Umbraco.Cms.Web.Common.DependencyInjection;
 using Umbraco.Extensions;
 using Constants = Umbraco.Cms.Core.Constants;
 
@@ -24,6 +26,7 @@ namespace Umbraco.Cms.Infrastructure.Install
         private readonly ICookieManager _cookieManager;
         private readonly IUserAgentProvider _userAgentProvider;
         private readonly IUmbracoDatabaseFactory _umbracoDatabaseFactory;
+        private readonly IFireAndForgetRunner _fireAndForgetRunner;
         private InstallationType? _installationType;
 
         public InstallHelper(
@@ -34,7 +37,8 @@ namespace Umbraco.Cms.Infrastructure.Install
             IInstallationService installationService,
             ICookieManager cookieManager,
             IUserAgentProvider userAgentProvider,
-            IUmbracoDatabaseFactory umbracoDatabaseFactory)
+            IUmbracoDatabaseFactory umbracoDatabaseFactory,
+            IFireAndForgetRunner fireAndForgetRunner)
         {
             _logger = logger;
             _umbracoVersion = umbracoVersion;
@@ -44,11 +48,36 @@ namespace Umbraco.Cms.Infrastructure.Install
             _cookieManager = cookieManager;
             _userAgentProvider = userAgentProvider;
             _umbracoDatabaseFactory = umbracoDatabaseFactory;
+            _fireAndForgetRunner = fireAndForgetRunner;
 
             // We need to initialize the type already, as we can't detect later, if the connection string is added on the fly.
             GetInstallationType();
         }
 
+        [Obsolete("Please use constructor that takes an IFireAndForgetRunner instead, scheduled for removal in Umbraco 12")]
+        public InstallHelper(
+            DatabaseBuilder databaseBuilder,
+            ILogger<InstallHelper> logger,
+            IUmbracoVersion umbracoVersion,
+            IOptionsMonitor<ConnectionStrings> connectionStrings,
+            IInstallationService installationService,
+            ICookieManager cookieManager,
+            IUserAgentProvider userAgentProvider,
+            IUmbracoDatabaseFactory umbracoDatabaseFactory)
+            : this(
+                databaseBuilder,
+                logger,
+                umbracoVersion,
+                connectionStrings,
+                installationService,
+                cookieManager,
+                userAgentProvider,
+                umbracoDatabaseFactory,
+                StaticServiceProvider.Instance.GetRequiredService<IFireAndForgetRunner>())
+        {
+
+        }
+
         public InstallationType GetInstallationType() => _installationType ??= IsBrandNewInstall ? InstallationType.NewInstall : InstallationType.Upgrade;
 
         public async Task SetInstallStatusAsync(bool isCompleted, string errorMsg)
@@ -87,7 +116,7 @@ namespace Umbraco.Cms.Infrastructure.Install
                     userAgent: userAgent,
                     dbProvider: dbProvider);
 
-                await _installationService.LogInstall(installLog);
+                _fireAndForgetRunner.RunFireAndForget(() => _installationService.LogInstall(installLog));
             }
             catch (Exception ex)
             {
diff --git a/src/Umbraco.Infrastructure/Packaging/PackageDataInstallation.cs b/src/Umbraco.Infrastructure/Packaging/PackageDataInstallation.cs
index b9960ab153..b4f49ab76b 100644
--- a/src/Umbraco.Infrastructure/Packaging/PackageDataInstallation.cs
+++ b/src/Umbraco.Infrastructure/Packaging/PackageDataInstallation.cs
@@ -1387,6 +1387,12 @@ namespace Umbraco.Cms.Infrastructure.Packaging
             return ImportDictionaryItems(dictionaryItemElementList, languages, null, userId);
         }
 
+        public IEnumerable<IDictionaryItem> ImportDictionaryItem(XElement dictionaryItemElement, int userId, Guid? parentId)
+        {
+            var languages = _localizationService.GetAllLanguages().ToList();
+            return ImportDictionaryItem(dictionaryItemElement, languages, parentId, userId);
+        }
+
         private IReadOnlyList<IDictionaryItem> ImportDictionaryItems(IEnumerable<XElement> dictionaryItemElementList,
             List<ILanguage> languages, Guid? parentId, int userId)
         {
diff --git a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/CreatedPackageSchemaRepository.cs b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/CreatedPackageSchemaRepository.cs
index 04c60261ea..9f921266ca 100644
--- a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/CreatedPackageSchemaRepository.cs
+++ b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/CreatedPackageSchemaRepository.cs
@@ -652,10 +652,13 @@ public class CreatedPackageSchemaRepository : ICreatedPackagesRepository
             // the media file path is different from the URL and is specifically
             // extracted using the property editor for this media file and the current media file system.
             Stream mediaStream = _mediaFileManager.GetFile(media, out var mediaFilePath);
-            xmlMedia.Add(new XAttribute("mediaFilePath", mediaFilePath!));
+            if (mediaFilePath is not null)
+            {
+                xmlMedia.Add(new XAttribute("mediaFilePath", mediaFilePath));
 
-            // add the stream to our outgoing stream
-            mediaStreams.Add(mediaFilePath!, mediaStream);
+                // add the stream to our outgoing stream
+                mediaStreams.Add(mediaFilePath, mediaStream);
+            }
         }
 
         IEnumerable<IMedia> medias = _mediaService.GetByIds(definition.MediaUdis);
diff --git a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/MemberRepository.cs b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/MemberRepository.cs
index 817a26aac1..bd08addddb 100644
--- a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/MemberRepository.cs
+++ b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/MemberRepository.cs
@@ -781,6 +781,11 @@ public class MemberRepository : ContentRepositoryBase<int, IMember, MemberReposi
             changedCols.Add("passwordConfig");
         }
 
+        if (entity.IsPropertyDirty("EmailConfirmedDate"))
+        {
+            changedCols.Add("emailConfirmedDate");
+        }
+
         // If userlogin or the email has changed then need to reset security stamp
         if (changedCols.Contains("Email") || changedCols.Contains("LoginName"))
         {
diff --git a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/RedirectUrlRepository.cs b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/RedirectUrlRepository.cs
index 512eed0ee9..1c2da42561 100644
--- a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/RedirectUrlRepository.cs
+++ b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/RedirectUrlRepository.cs
@@ -1,4 +1,5 @@
 using System.Security.Cryptography;
+using System.Threading.Tasks;
 using Microsoft.Extensions.Logging;
 using NPoco;
 using Umbraco.Cms.Core;
@@ -36,14 +37,28 @@ internal class RedirectUrlRepository : EntityRepositoryBase<Guid, IRedirectUrl>,
     public void Delete(Guid id) => Database.Delete<RedirectUrlDto>(id);
 
     public IRedirectUrl? GetMostRecentUrl(string url)
+    {
+        Sql<ISqlContext> sql = GetMostRecentSql(url);
+        List<RedirectUrlDto> dtos = Database.Fetch<RedirectUrlDto>(sql);
+        RedirectUrlDto? dto = dtos.FirstOrDefault();
+        return dto == null ? null : Map(dto);
+    }
+
+    public  async Task<IRedirectUrl?> GetMostRecentUrlAsync(string url)
+    {
+        Sql<ISqlContext> sql = GetMostRecentSql(url);
+        List<RedirectUrlDto> dtos = await Database.FetchAsync<RedirectUrlDto>(sql);
+        RedirectUrlDto? dto = dtos.FirstOrDefault();
+        return dto == null ? null : Map(dto);
+    }
+
+    private Sql<ISqlContext> GetMostRecentSql(string url)
     {
         var urlHash = url.GenerateHash<SHA1>();
         Sql<ISqlContext> sql = GetBaseQuery(false)
             .Where<RedirectUrlDto>(x => x.Url == url && x.UrlHash == urlHash)
             .OrderByDescending<RedirectUrlDto>(x => x.CreateDateUtc);
-        List<RedirectUrlDto> dtos = Database.Fetch<RedirectUrlDto>(sql);
-        RedirectUrlDto? dto = dtos.FirstOrDefault();
-        return dto == null ? null : Map(dto);
+        return sql;
     }
 
     public IRedirectUrl? GetMostRecentUrl(string url, string culture)
@@ -53,13 +68,40 @@ internal class RedirectUrlRepository : EntityRepositoryBase<Guid, IRedirectUrl>,
             return GetMostRecentUrl(url);
         }
 
+        Sql<ISqlContext> sql = GetMostRecentUrlSql(url, culture);
+
+        List<RedirectUrlDto> dtos = Database.Fetch<RedirectUrlDto>(sql);
+        RedirectUrlDto? dto = dtos.FirstOrDefault(f => f.Culture == culture.ToLower());
+
+        if (dto == null)
+        {
+            dto = dtos.FirstOrDefault(f => string.IsNullOrWhiteSpace(f.Culture));
+        }
+
+        return dto == null ? null : Map(dto);
+    }
+
+    private Sql<ISqlContext> GetMostRecentUrlSql(string url, string culture)
+    {
         var urlHash = url.GenerateHash<SHA1>();
         Sql<ISqlContext> sql = GetBaseQuery(false)
             .Where<RedirectUrlDto>(x => x.Url == url && x.UrlHash == urlHash &&
                                         (x.Culture == culture.ToLower() || x.Culture == null ||
                                          x.Culture == string.Empty))
             .OrderByDescending<RedirectUrlDto>(x => x.CreateDateUtc);
-        List<RedirectUrlDto> dtos = Database.Fetch<RedirectUrlDto>(sql);
+        return sql;
+    }
+
+    public async Task<IRedirectUrl?> GetMostRecentUrlAsync(string url, string culture)
+    {
+        if (string.IsNullOrWhiteSpace(culture))
+        {
+            return GetMostRecentUrl(url);
+        }
+
+        Sql<ISqlContext> sql = GetMostRecentUrlSql(url, culture);
+
+        List<RedirectUrlDto> dtos = await Database.FetchAsync<RedirectUrlDto>(sql);
         RedirectUrlDto? dto = dtos.FirstOrDefault(f => f.Culture == culture.ToLower());
 
         if (dto == null)
diff --git a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/TemplateRepository.cs b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/TemplateRepository.cs
index 1a0a90269c..9e01320fdc 100644
--- a/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/TemplateRepository.cs
+++ b/src/Umbraco.Infrastructure/Persistence/Repositories/Implement/TemplateRepository.cs
@@ -1,8 +1,10 @@
 using System.Text;
 using Microsoft.Extensions.Logging;
+using Microsoft.Extensions.Options;
 using NPoco;
 using Umbraco.Cms.Core;
 using Umbraco.Cms.Core.Cache;
+using Umbraco.Cms.Core.Configuration.Models;
 using Umbraco.Cms.Core.IO;
 using Umbraco.Cms.Core.Models;
 using Umbraco.Cms.Core.Models.Entities;
@@ -24,17 +26,26 @@ internal class TemplateRepository : EntityRepositoryBase<int, ITemplate>, ITempl
 {
     private readonly IIOHelper _ioHelper;
     private readonly IShortStringHelper _shortStringHelper;
-    private readonly IViewHelper _viewHelper;
     private readonly IFileSystem? _viewsFileSystem;
+    private readonly IViewHelper _viewHelper;
+    private readonly IOptionsMonitor<RuntimeSettings> _runtimeSettings;
 
-    public TemplateRepository(IScopeAccessor scopeAccessor, AppCaches cache, ILogger<TemplateRepository> logger,
-        FileSystems fileSystems, IIOHelper ioHelper, IShortStringHelper shortStringHelper, IViewHelper viewHelper)
+    public TemplateRepository(
+        IScopeAccessor scopeAccessor,
+        AppCaches cache,
+        ILogger<TemplateRepository> logger,
+        FileSystems fileSystems,
+        IIOHelper ioHelper,
+        IShortStringHelper shortStringHelper,
+        IViewHelper viewHelper,
+        IOptionsMonitor<RuntimeSettings> runtimeSettings)
         : base(scopeAccessor, cache, logger)
     {
         _ioHelper = ioHelper;
         _shortStringHelper = shortStringHelper;
         _viewsFileSystem = fileSystems.MvcViewsFileSystem;
         _viewHelper = viewHelper;
+        _runtimeSettings = runtimeSettings;
     }
 
     public Stream GetFileContentStream(string filepath)
@@ -421,8 +432,12 @@ internal class TemplateRepository : EntityRepositoryBase<int, ITemplate>, ITempl
         template.Id = nodeDto.NodeId; //Set Id on entity to ensure an Id is set
         template.Path = nodeDto.Path;
 
-        //now do the file work
-        SaveFile(template);
+        // Only save file when not in production runtime mode
+        if (_runtimeSettings.CurrentValue.Mode != RuntimeMode.Production)
+        {
+            //now do the file work
+            SaveFile(template);
+        }
 
         template.ResetDirtyProperties();
 
@@ -476,8 +491,12 @@ internal class TemplateRepository : EntityRepositoryBase<int, ITemplate>, ITempl
         IEnumerable<IUmbracoEntity> axisDefs = GetAxisDefinitions(dto);
         template.IsMasterTemplate = axisDefs.Any(x => x.ParentId == dto.NodeId);
 
-        //now do the file work
-        SaveFile((Template)entity, originalAlias);
+        // Only save file when not in production runtime mode
+        if (_runtimeSettings.CurrentValue.Mode != RuntimeMode.Production)
+        {
+            //now do the file work
+            SaveFile((Template)entity, originalAlias);
+        }
 
         entity.ResetDirtyProperties();
 
diff --git a/src/Umbraco.Infrastructure/PublishedContentQuery.cs b/src/Umbraco.Infrastructure/PublishedContentQuery.cs
index 891f938a2b..ef16aeccc6 100644
--- a/src/Umbraco.Infrastructure/PublishedContentQuery.cs
+++ b/src/Umbraco.Infrastructure/PublishedContentQuery.cs
@@ -18,11 +18,11 @@ namespace Umbraco.Cms.Infrastructure;
 /// <seealso cref="Umbraco.Cms.Core.IPublishedContentQuery" />
 public class PublishedContentQuery : IPublishedContentQuery
 {
-    private static readonly HashSet<string> _itemIdFieldNameHashSet = new() {ExamineFieldNames.ItemIdFieldName};
-
     private readonly IExamineManager _examineManager;
     private readonly IPublishedSnapshot _publishedSnapshot;
     private readonly IVariationContextAccessor _variationContextAccessor;
+    private static readonly HashSet<string> _returnedQueryFields =
+        new() { ExamineFieldNames.ItemIdFieldName, ExamineFieldNames.CategoryFieldName };
 
     /// <summary>
     ///     Initializes a new instance of the <see cref="PublishedContentQuery" /> class.
@@ -293,8 +293,8 @@ public class PublishedContentQuery : IPublishedContentQuery
             ordering = query.ManagedQuery(term, fields);
         }
 
-        // Only select item ID field, because results are loaded from the published snapshot based on this single value
-        IOrdering? queryExecutor = ordering.SelectFields(_itemIdFieldNameHashSet);
+            // Filter selected fields because results are loaded from the published snapshot based on these
+            IOrdering? queryExecutor = ordering.SelectFields(_returnedQueryFields);
 
 
         ISearchResults? results = skip == 0 && take == 0
@@ -328,8 +328,8 @@ public class PublishedContentQuery : IPublishedContentQuery
 
         if (query is IOrdering ordering)
         {
-            // Only select item ID field, because results are loaded from the published snapshot based on this single value
-            query = ordering.SelectFields(_itemIdFieldNameHashSet);
+                // Filter selected fields because results are loaded from the published snapshot based on these
+                query = ordering.SelectFields(_returnedQueryFields);
         }
 
         ISearchResults? results = skip == 0 && take == 0
